<template>
  <Dropdown
    v-model="menuItems"
    class="text-lg"
  >
    <template #default="{ toggle, shown }">
      <Button
        :shown="shown"
        @toggle="toggle"
      />
    </template>
  </Dropdown>
</template>

<script lang="ts" setup>
import Button from './Button.vue';
import { Dropdown } from '~shared/ui';
import { type IDropdownElem } from '~/shared/model';
import { icons } from '~shared/libs';
import { useAuthStore } from '~/stores/auth';
import { useTasksStore } from '~stores/tasks';
import type { ITask } from '~/entities/tasks';
import { usePopupsStore } from '~/stores/popups';
import { USER_SETTINGS_POPUP } from '~entities/popups';

const { logout } = useAuthStore();
const { addTask } = useTasksStore();
const { showPopup } = usePopupsStore();

const menuItems = [
  {
    title: 'add list',
    icon: icons.addListIcon,
    action: () => addTask({} as ITask),
  },
  {
    title: 'account',
    icon: icons.userIcon,
    action: () => showPopup(USER_SETTINGS_POPUP),
  },
  { title: 'logout', icon: icons.logoutIcon, action: logout },
] as IDropdownElem[];
</script>
